/*:
## **Einleitungsaufgabe Aquarium**
*/

/**
Oberklasse aller Fische

- author: Albert Wiedemann
- version: 1.0
*/
class Fisch: Figur
{
    /** Blick- und Schwimmrichtung */
    var blickrichtung: Character
    /** Schwimmgeschwindigkeit */
    var geschwindigkeit: Int
    /** Schwimmhöhe */
    var höhe: Int
    /** Position waagrecht */
    var x: Int

    /**
	Belegt die Startposition
	- parameters:
		- xstart: Startposition waagrecht
		- ausgangshöhe: Schwimmhöhe zu Beginn
     */
    init(xstart: Int, ausgangshöhe: Int)
    {
        höhe = ausgangshöhe
        x = xstart
        blickrichtung = "r"
        geschwindigkeit = 0
        super.init()
        PositionSetzen(x: x, y: höhe)
    }

    /**
    Erzeugt die nach rechts blickende Figur und setzt die Blickrichtung
    */
    func FigurRechtsBlickendSetzen()
    {
    }

    /**
    Erzeugt die nach links blickende Figur und setzt die Blickrichtung
    */
    func FigurLinksBlickendSetzen()
    {
    }

    /**
    Bewegt den Fisch
    */
    func Schwimmen()
    {
        if blickrichtung == "l"
        {
            if x < 100
            {
                FigurRechtsBlickendSetzen()
                x = x + 100
            }
            else
            {
                x = x - 100
            }
        }
        else
        {
            if x > 700
            {
                FigurLinksBlickendSetzen()
                x = x - 100
            }
            else
            {
                x = x + 100
            }
        }
        PositionSetzen(x: x, y: höhe)
    }
}

/**
Beschreibt einen Clownfisch

- author: Albert Wiedemann
- version: 1.0
*/
class Clownfisch: Fisch
{
    /** Zufallsgenerator für zufällige Bewegungen */
    var zufall: Zufall
    
    /**
	Belegt die Startposition
	- parameters:
		- xstart: Startposition waagrecht
		- ausgangshöhe: Schwimmhöhe zu Beginn
     */
    override init(xstart: Int, ausgangshöhe: Int)
    {
        zufall = Zufall()
        super.init(xstart: xstart, ausgangshöhe: ausgangshöhe)
        FigurLinksBlickendSetzen()
    }

    /**
    Erzeugt die nach rechts blickende Figur und setzt die Blickrichtung
    */
    override func FigurRechtsBlickendSetzen()
    {
        blickrichtung = "r"
        EigeneFigurLöschen()
        // Schwanz
        FigurteilFestlegenDreieck(x1: -50, y1: -10, x2: -50, y2: 20, x3: -40, y3: -20, farbe: "orange")
        FigurteilFestlegenDreieck(x1: -40, y1: -20, x2: -50, y2: 20, x3: -40, y3: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: -40, y1: -20, x2: -40, y2: 30, x3: -30, y3: 0, farbe: "weiß")
        FigurteilFestlegenDreieck(x1: -30, y1: 0, x2: -40, y2: 30, x3: -30, y3: 10, farbe: "orange")
        // Körper
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -20, y2: -30, x3: -30, y3: 0, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -30, y2: 0, x3: -30, y3: 10, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -30, y2: 10, x3: -20, y3: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -20, y2: 30, x3: 10, y3: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 10, y2: 30, x3: 40, y3: 20, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 40, y2: 20, x3: 50, y3: 0, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 50, y2: 0, x3: 50, y3: -10, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 50, y2: -10, x3: 20, y3: -40, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -20, y2: 0, x3: -10, y3: 30, farbe: "weiß")
        FigurteilFestlegenDreieck(x1: 30, y1: -30, x2: 10, y2: -10, x3: 10, y3: 30, farbe: "weiß")
        // Auge
        FigurteilFestlegenEllipse(x: 25, y: -35, breite: 30, höhe: 30, farbe: "weiß")
        FigurteilFestlegenEllipse(x: 40, y: -20, breite: 10, höhe: 10, farbe: "blau")
    }

    /**
    Erzeugt die nach links blickende Figur und setzt die Blickrichtung
    */
    override func FigurLinksBlickendSetzen()
    {
        blickrichtung = "l"
        EigeneFigurLöschen()
        // Schwanz
        FigurteilFestlegenDreieck(x1: 50, y1: -10, x2: 50, y2: 20, x3: 40, y3: -20, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 40, y1: -20, x2: 50, y2: 20, x3: 40, y3: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 40, y1: -20, x2: 40, y2: 30, x3: 30, y3: 0, farbe: "weiß")
        FigurteilFestlegenDreieck(x1: 30, y1: 0, x2: 40, y2: 30, x3: 30, y3: 10, farbe: "orange")
        // Körper
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 20, y2: -30, x3: 30, y3: 0, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 30, y2: 0, x3: 30, y3: 10, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 30, y2: 10, x3: 20, y3: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 20, y2: 30, x3: -10, y3: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -10, y2: 30, x3: -40, y3: 20, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -40, y2: 20, x3: -50, y3: 0, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -50, y2: 0, x3: -50, y3: -10, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: -50, y2: -10, x3: -20, y3: -40, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: -40, x2: 20, y2: 0, x3: 10, y3: 30, farbe: "weiß")
        FigurteilFestlegenDreieck(x1: -30, y1: -30, x2: -10, y2: -10, x3: -10, y3: 30, farbe: "weiß")
        // Auge
        FigurteilFestlegenEllipse(x: -55, y: -35, breite: 30, höhe: 30, farbe: "weiß")
        FigurteilFestlegenEllipse(x: -50, y: -20, breite: 10, höhe: 10, farbe: "blau")
    }
    
    /**
    Bewegt den Fisch
    */
    override func Schwimmen()
    {
        if blickrichtung == "l"
        {
            if x < 60
            {
                FigurRechtsBlickendSetzen()
                x = x + 30
                höhe = höhe + 15
            }
            else
            {
                x = x - 30
                höhe = höhe - 15
            }
        }
        else
        {
            if x > 730
            {
                FigurLinksBlickendSetzen()
                x = x - 30
                höhe = höhe - 15
            }
            else
            {
                x = x + 30
                höhe = höhe + 15
            }
        }
        höhe = höhe < 5 ? 5 : höhe > 485 ? 485 : höhe
        PositionSetzen(x: x, y: höhe)
    }
}

/**
Beschreibt einen Piranha

- author: Albert Wiedemann
- version: 1.0
*/
class Piranha: Fisch
{
    
    /**
	Belegt die Startposition
	- parameters:
		- xstart: Startposition waagrecht
		- ausgangshöhe: Schwimmhöhe zu Beginn
     */
    override init(xstart: Int, ausgangshöhe: Int)
    {
        super.init(xstart: xstart, ausgangshöhe: ausgangshöhe)
        FigurLinksBlickendSetzen()
    }

    /**
    Erzeugt die nach rechts blickende Figur und setzt die Blickrichtung
    */
    override func FigurRechtsBlickendSetzen()
    {
        blickrichtung = "r";
        EigeneFigurLöschen();
        FigurteilFestlegenDreieck(x1: -50,y1: 50,x2: -40,y2: 0,x3: -20,y3: 0,farbe: "grau")
        FigurteilFestlegenDreieck(x1: -40,y1: 0,x2: -50,y2: -50,x3: -20,y3: 0,farbe: "grau")
        FigurteilFestlegenDreieck(x1: -40,y1: 0,x2: -32,y2: 20,x3: -10,y3: 30,farbe: "grau")
        // Afterflosse
        FigurteilFestlegenDreieck(x1: -32,y1: 20,x2: -30,y2: 40,x3: -10,y3: 30,farbe: "schwarz")
        FigurteilFestlegenDreieck(x1: -40,y1: 0,x2: -10,y2: 30,x3: 20,y3: 30,farbe: "grau")
        FigurteilFestlegenDreieck(x1: -40,y1: 0,x2: 20,y2: 30,x3: 40,y3: 20,farbe: "grau")
        // Bauchflosse
        FigurteilFestlegenDreieck(x1: 20,y1: 30,x2: 40,y2: 40,x3: 40,y3: 20,farbe: "schwarz")
        FigurteilFestlegenDreieck(x1: -40,y1: 0,x2: 40,y2: 20,x3: 50,y3: 0,farbe: "grau")
        FigurteilFestlegenDreieck(x1: -40,y1: 0,x2: 30,y2: 0,x3: 10,y3: -30,farbe: "grau")
        // Rueckenflosse
        FigurteilFestlegenDreieck(x1: -10,y1: -50,x2: 30,y2: 0,x3: 50,y3: -20,farbe: "grau")
        FigurteilFestlegenDreieck(x1: 40,y1: -10,x2: 50,y2: -10,x3: 50,y3: -20,farbe: "grau")
        FigurteilFestlegenEllipse(x: 25,y: -25,breite: 10,höhe: 10,farbe: "rot")
    }

    /**
    Erzeugt die nach links blickende Figur und setzt die Blickrichtung
    */
    override func FigurLinksBlickendSetzen()
    {
        blickrichtung = "l"
        EigeneFigurLöschen()
        FigurteilFestlegenDreieck(x1: 50,y1: 50,x2: 40,y2: 0,x3: 20,y3: 0,farbe: "grau")
        FigurteilFestlegenDreieck(x1: 40,y1: 0,x2: 50,y2: -50,x3: 20,y3: 0,farbe: "grau")
        FigurteilFestlegenDreieck(x1: 40,y1: 0,x2: 32,y2: 20,x3: 10,y3: 30,farbe: "grau")
        // Afterflosse
        FigurteilFestlegenDreieck(x1: 32,y1: 20,x2: 30,y2: 40,x3: 10,y3: 30,farbe: "schwarz")
        FigurteilFestlegenDreieck(x1: 40,y1: 0,x2: 10,y2: 30,x3: -20,y3: 30,farbe: "grau")
        FigurteilFestlegenDreieck(x1: 40,y1: 0,x2: -20,y2: 30,x3: -40,y3: 20,farbe: "grau")
        // Bauchflosse
        FigurteilFestlegenDreieck(x1: -20,y1: 30,x2: -40,y2: 40,x3: -40,y3: 20,farbe: "schwarz")
        FigurteilFestlegenDreieck(x1: 40,y1: 0,x2: -40,y2: 20,x3: -50,y3: 0,farbe: "grau")
        FigurteilFestlegenDreieck(x1: 40,y1: 0,x2: -30,y2: 0,x3: -10,y3: -30,farbe: "grau")
        // Rueckenflosse
        FigurteilFestlegenDreieck(x1: 10,y1: -50,x2: -30,y2: 0,x3: -50,y3: -20,farbe: "grau")
        FigurteilFestlegenDreieck(x1: -40,y1: -10,x2: -50,y2: -10,x3: -50,y3: -20,farbe: "grau")
        FigurteilFestlegenEllipse(x: -35,y: -25,breite: 10,höhe: 10,farbe: "rot")
    }
    
    /**
     * Bewegt den Fisch
     */
    override func Schwimmen()
    {
        if blickrichtung == "l"
        {
            if x < 60
            {
                FigurRechtsBlickendSetzen()
                x = x + 70
                höhe = höhe - 5
            }
            else
            {
                x = x - 70
                höhe = höhe + 5
            }
        }
        else
        {
            if x > 730
            {
                FigurLinksBlickendSetzen()
                x = x - 70
                höhe = höhe + 5
            }
            else
            {
                x = x + 70
                höhe = höhe - 5
            }
        }
        höhe = höhe < 5 ? 5 : höhe > 485 ? 485 : höhe
        PositionSetzen(x: x, y: höhe)
    }
}

/**
Verwaltet das Aquarium

- author: Albert Wiedemann
- version: 1.0
 */
class Aquarium: Ereignisbehandlung
{
    /** Zufallsgenerator */
    private let zufall: Zufall
    /** Feld der Fische */
    var fische: [Fisch]

    /**
    Legt die Fische an und startet den Taktgenerator
    */
    override init()
    {
        zufall = Zufall()
        fische = [Fisch]()
        super.init()
        let hintergrund = Rechteck()
        hintergrund.FarbeSetzen(farbe: "blau")
        hintergrund.PositionSetzen(x: 0, y: 0)
        hintergrund.GrößeSetzen(breite: 800, höhe: 510)
        for _ in 1 ... 10
        {
            let x = 100 + zufall.ZufallGanz(top: 600)
            let höhe = 50 + zufall.ZufallGanz(top: 400)
            fische.append(zufall.ZufallGanz(top: 100) < 50 ? Clownfisch (xstart: x, ausgangshöhe: höhe) : Piranha (xstart: x, ausgangshöhe: höhe))
        }
        TaktdauerSetzen(dauer: 500)
        Starten()
    }

    /**
    Bewegt alle Fische
    */
    override func TaktImpulsAusführen()
    {
        for f  in fische
        {
            f.Schwimmen()
        }
    }
}

Aquarium()
