/*:
## **Aufgabe Medienverwaltung**
*/

/**
Oberklasse aller Medien

- author: Albert Wiedemann
- version: 1.0
*/
class Medium
{
    /** Name des Mediums */
    let name: String

    /**
	Speichert den Namen
	- parameters:
		- name: der Name des Mediums
    */
    init(name: String)
    {
        self.name = name
    }
}

/**
Beschreibt einen Film

- author: Albert Wiedemann
- version: 1.0
*/
class Film: Medium
{
    /** Der Regisseur, der den Film produziert hat */
    private let regisseur: String

    /**
	Legt die Daten an
	- parameters:
		- name: der Name des Mediums
		- regisseur: der Name des Regisseurs
    */
    init(name: String, regisseur: String)
    {
        self.regisseur = regisseur
        super.init(name: name)
    }
}

/**
Beschreibt einen Song

- author: Albert Wiedemann
- version: 1.0
*/
class Song: Medium
{
    /** Der Künstler, der den Song interpretiert */
    private let künstler: String

    /**
	Legt die Daten an
	- parameters:
		- name: der Name des Mediums
		- künstler: der Name des Künstlers
    */
    init(name: String, künstler: String)
    {
        self.künstler = künstler
        super.init(name: name)
    }
}

